
/********************************************************************************/
/*                                                                              */
/*  Practica de Arquitectures Orientades a les Aplicacions                      */
/*                                                                              */
/*  Versio SISTOLICA del programa de comparacio de les paraules d'un text       */
/*  amb un mot clau per mitja de la Distancia de Levenshtein.                   */
/*  Implementacio amb C-stolic de l'algorisme de la distancia de Levenshtein.   */
/*  Autors: Francisco Jose Aguilar Celdran                                      */
/*          Sergio Blanco Cuaresma                                              */
/*                                                                              */
/********************************************************************************/


/* ------------------------------------------------------------------------------------------- */
/*  DISTANCIA_LEVENSHTEIN: obte la distancia entre dues paraules segons l'esmentat algorisme.  */
/* ------------------------------------------------------------------------------------------- */

int distancia_levenshtein (char *cadena_a, char *cadena_b)
{
   int longitud_a;
   int longitud_b;
   int **matriu;
   int opcio[3];
   int minim;
   int cost;
   int i, j, k;
   int resultat;
   
   longitud_a = strlen(cadena_a);
   longitud_b = strlen(cadena_b);
   if (longitud_a == 0) {
      return longitud_b;
   }
   else if (longitud_b == 0) {
      return longitud_a;
   }
   else {
      // Creacio dinamica de la matriu
      matriu = (int **) malloc((longitud_b + 1) * sizeof(int *));
      for (i = 0; i <= longitud_b; i++) {
         matriu[i] = (int *) malloc((longitud_a + 1) * sizeof(int));
      }
      // Inicialitzacio de la primera fila i columna de la matriu
      for (j = 0; j <= longitud_a; j++) {
         matriu[0][j] = j;
      }
      for (i = 0; i <= longitud_b; i++) {
         matriu[i][0] = i;
      }
      // Calcul de la Distancia de Levenshtein
      for(i = 1; i <= longitud_b; i++) {
         for(j = 1; j <= longitud_a; j++) { 
            if (cadena_a[i - 1] == cadena_b[j - 1]) {
               cost = 0;
            }
            else {
               cost = 1;
            }
            // S'assigna a la cella [i][j] de la matriu el valor menor de les tres opcions
            opcio[0] = matriu[i-1][j] + 1;
            opcio[1] = matriu[i][j-1] + 1;
            opcio[2] = matriu[i-1][j-1] + cost;
            minim = 32500;
            for (k = 0; k < 3; k++) {
               if (opcio[k] < minim) {
                  minim = opcio[k];
               }
            }
            matriu[i][j] = minim;
         }
      }
      resultat = matriu[longitud_b][longitud_a];
      free(matriu);
      return resultat;
   }
}
